# -*- coding: UTF-8 -*-

# Addon Name: Cyberscrapers
# Addon id: script.module.Cyberscrapers

import os
import hashlib
import kodi
from random import choice

addon_path = kodi.get_path()
plugins_path = os.path.join(addon_path, 'lib', 'Cyberscrapers', 'plugins')
profile_path = kodi.translate_path(kodi.get_profile())
settings_file = os.path.join(addon_path, 'resources', 'settings.xml')
addon_version = kodi.get_version()
get_setting = kodi.get_setting
set_setting = kodi.set_setting
open_settings = kodi.open_settings
has_addon = kodi.has_addon