# -*- coding: utf-8 -*-

# Addon Name: Cyberscrapers
# Addon id: script.module.Cyberscrapers

import urlparse

from Cyberscrapers import sources_Cyberscrapers
from Cyberscrapers.modules import control

params = dict(urlparse.parse_qsl(sys.argv[2].replace('?', '')))
action = params.get('action')
mode = params.get('mode')
query = params.get('query')

def ScraperChoice():
	from Cyberscrapers import providerSources
	sourceList = sorted(providerSources())
	control.idle()
	select = control.selectDialog([i for i in sourceList])
	if select == -1: return
	module_choice = sourceList[select]
	control.setSetting('module.provider', module_choice)
	control.openSettings('0.1')

if action == "CyberscrapersSettings":
	control.openSettings('0.0', 'script.module.Cyberscrapers')

elif mode == "CyberscrapersSettings":
	control.openSettings('0.0', 'script.module.Cyberscrapers')

elif action == "ScraperChoice":
	ScraperChoice()

elif action == "toggleAll":
	sourceList = []
	sourceList = sources_Cyberscrapers.all_providers
	for i in sourceList:
		source_setting = 'provider.' + i
		control.setSetting(source_setting, params['setting'])
	#    xbmc.log('All providers = %s' % sourceList,2)
	control.openSettings(query, "script.module.Cyberscrapers")

elif action == "toggleAllHosters":
	sourceList = []
	sourceList = sources_Cyberscrapers.hoster_providers
	for i in sourceList:
		source_setting = 'provider.' + i
		control.setSetting(source_setting, params['setting'])
	#    xbmc.log('All Hoster providers = %s' % sourceList,2)
	control.openSettings(query, "script.module.Cyberscrapers")

elif action == "toggleAllPaid":
	sourceList = []
	sourceList = sources_Cyberscrapers.all_paid_providers
	for i in sourceList:
		source_setting = 'provider.' + i
		control.setSetting(source_setting, params['setting'])
	#    xbmc.log('All Paid providers = %s' % sourceList,2)
	control.openSettings(query, "script.module.Cyberscrapers")

elif action == "toggleAllDebrid":
	sourceList = []
	sourceList = sources_Cyberscrapers.debrid_providers
	for i in sourceList:
		source_setting = 'provider.' + i
		control.setSetting(source_setting, params['setting'])
	#    xbmc.log('All Debrid providers = %s' % sourceList,2)
	control.openSettings(query, "script.module.Cyberscrapers")

elif action == "toggleAllTorrent":
	sourceList = []
	sourceList = sources_Cyberscrapers.torrent_providers
	for i in sourceList:
		source_setting = 'provider.' + i
		control.setSetting(source_setting, params['setting'])
	#    xbmc.log('All Torrent providers = %s' % sourceList,2)
	control.openSettings(query, "script.module.Cyberscrapers")

	for i in sourceList:
		source_setting = 'provider.' + i
		control.setSetting(source_setting, params['setting'])
	control.openSettings(query, "script.module.Cyberscrapers")
