# -*- coding: UTF-8 -*-
# -Cleaned and Checked on 26-09-20.

import re

from Cyberscrapers.modules import cleantitle
from Cyberscrapers.modules import client
from Cyberscrapers.modules import source_utils


class source:
	def __init__(self):
		self.priority = 35
		self.language = ['en']
		self.domains = ['bnwmovies.com']
		self.base_link = 'http://www.bnwmovies.com'
		self.search_link = '/?s=%s'

	def movie(self, imdb, title, localtitle, aliases, year):
		try:
			scrape = title.lower().replace(' ', '+').replace(':', '')
			start_url = self.base_link + self.search_link % scrape
			html = client.request(start_url, timeout='5')
			if not html:
				return
			results = re.compile('href="(.+?)"', re.DOTALL).findall(html)
			for url in results:
				if self.base_link in url:
					if 'webcache' in url:
						continue
					if cleantitle.geturl(title) in url:
						chkhtml = client.request(url, timeout='5')
						chktitle = re.compile('<title.+?>(.+?)</title>', re.DOTALL).findall(chkhtml)[0]
						if title in chktitle:
							if str(year) in chktitle:
								return url
			return
		except:
			source_utils.scraper_error('BNWMOVIES')
			return


	def sources(self, url, hostDict, hostprDict):
		try:
			sources = []
			if url is None:
				return sources
			html = client.request(url, timeout='5')
			Links = re.compile('<source.+?src="(.+?)"', re.DOTALL).findall(html)
			for link in Links:
				sources.append({'source': 'BNW', 'quality': 'SD', 'info': '', 'language': 'en', 'url': link, 'direct': True,
				                'debridonly': False})
			return sources
		except:
			source_utils.scraper_error('BNWMOVIES')
			return sources


	def resolve(self, url):
		return url